// $Id: contentanalysis.js,v 1.5 2010/05/08 16:12:13 tomdude48 Exp $

if (Drupal.jsEnabled) {
  $(document).ready(function () {
	if(Drupal.settings.contentanalysis.analyze_on_start == 1) {
//	  contentanalysis_analyze();	 
    }
  });
}


Drupal.behaviors.contentanalysisui = function () {
  $('div.analysis-results div.analyzer-analysis:eq(0)').show()
    $('.content-analysis-results:first').show()
    $('.analyzers h3.analyzer:first').addClass('active')
    $('h3.content-analysis-tab:first').addClass('active')
    $('div.analyzers h3.analyzer').mousedown(function () {
      $('h3.content-analysis-tab').removeClass('active')
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').children('.content-analysis-tab:first').addClass('active')
      $('div.analysis-results div.analyzer-analysis').hide()
      $('.analyzers h3.analyzer').removeClass('active')
      $(this).addClass('active')
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').show()
      $('.content-analysis-results').hide()
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').children('.content-analysis-results:first').show()
    }) 
    $('h3.content-analysis-tab').mousedown(function () { 
      $('h3.content-analysis-tab').removeClass('active')
      $('.content-analysis-results').hide()
      $(this).addClass('active') 
      $(this).next().show()
    })
}

var contentanalysis_analyze = function() {
  // if TinyMCE is used, turn off and on to save body text to textarea

  var data = { 
    'nid': -1,
    'node_type': -1,
    'source': -1,
    'analyzers':-1,
    'title': -1, 
    'body': -1,
    'page_title':-1, 
    'meta_keywords':-1, 
    'meta_description':-1,
    'url': -1,
    'page': -1,
    'body_input_filter': -1,
    'hidden': -1,    'code': Drupal.settings.contentanalysis.code
  };
  if ($('#contentanalysis-page-analyzer-form').html()) {
    data.source = 'admin-form';
    data.body = $('[name=input]').val()
    data.nid = $('[name=input_nid]').val()
    data.url = $('[name=input_url]').val()
    if(data.body == '') {
      data.body = -1;
    }
    if(data.nid == '') {
      data.nid = -1;
    }
    if(data.url == '') {
      data.url = -1;
    }    
  } else if ($('#node-form').html()) {
    data.source = 'node-edit-form';
    if(typeof mceToggle == 'function') {
      mceToggle('edit-body', 'wysiwyg4body');
    }
    data.title = $('#edit-title').val();
    data.body = $('#edit-body').val();
    data.nid = Drupal.settings.contentanalysis.nid
    data.node_type = Drupal.settings.contentanalysis.node_type
    data.body_input_filter = $("input[name='format']:checked").val(); 
    if($('#edit-page-title').val() != null) {
      data.page_title = $('#edit-page-title').val();
    }
    // check for deprecated nodewords format
    if($('#edit-nodewords-keywords') != null) {
      data.meta_keywords = $('#edit-nodewords-keywords').val();
    }
    if($('#edit-nodewords-description') != null) {
      data.meta_description = $('#edit-nodewords-description').val();
    }
    // newer nodewords format
    if($('#edit-nodewords-keywords-value') != null) {
      data.meta_keywords = $('#edit-nodewords-keywords-value').val();
    }
    if($('#edit-nodewords-description-value') != null) {
      data.meta_description = $('#edit-nodewords-description-value').val();
    }
    if($('#edit-path') != null) {
      data.url = window.location.host + Drupal.settings.contentanalysis.base_path + $('#edit-path').val();
    }
    if(typeof mceToggle == 'function') {
      mceToggle('edit-body', 'wysiwyg4body');
    }	
  } else {
    data.source = 'page-link';
    data.page = $('html').html()  
    data.url = window.location.href
  }
  if(Drupal.settings.contentanalysis.hidden != null) {
    data.hidden = Drupal.settings.contentanalysis.hidden;
  }
  
  //alert('data.nid ' + data.nid)
  if($('#contentanalysis_analyzers_override input').val() != null) {
    data.analyzers = $('#contentanalysis_analyzers_override input').val();
  } else {
    var a = new Array();
    var i = 0;
    $('#contentanalysis_analyzers .form-checkbox:checked').each ( function () {  
      var expr = new RegExp(/\[[^\]]+\]/);
      a[i] = expr.exec($(this).attr('name'))[0].replace(']', '').replace('[','');    
      i++;
    })
    data.analyzers = a.join(',');
  }

  modules = Drupal.settings.contentanalysis.analyzer_modules;
  for(i=0;i<modules.length;i++) {
    if (eval('typeof ' + modules[i]['module'] + '_contentanalysis_data == "function"')) {
      d = eval(modules[i]['module']+'_contentanalysis_data()');
      for(var k in d) {
        eval('data.ao_'+modules[i]['aid']+'_'+k+' = "'+d[k]+'";');
      }
    }
  }
  $.ajax({
    type: 'POST',
    url: Drupal.settings.contentanalysis.analyze_callback,
    data: data,
    dataType: 'json',
    success: function(data, textStatus) {
      $('#analysis-modal').append(data.main['output'])
      $('#analysis-modal .progress').remove()
      Drupal.behaviors.contentanalysisui()
      // call any modules post analysis hooks
      modules = Drupal.settings.contentanalysis.analyzer_modules;
      for(i=0;i<modules.length;i++) {
        if (eval('typeof ' + modules[i]['module'] + '_contentanalysis_analysis_success == "function"')) {
          eval(modules[i]['module']+'_contentanalysis_analysis_success()');
        }
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert("error " + XMLHttpRequest.toString());
    }
  });
  return false;	
}
